#ifndef _TEST_APP
#define _TEST_APP

#include <vector>
#include "hair_particle.h"
#include "ofMain.h"
#include "ofx3DUtils.h"

class testApp : public ofBaseApp{

	public:

		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void resized(int w, int h);
		//---custom
		void draw_tile(float aw, float ah, float ad, float ax,float ay, float az, float arot, float atw, float ath);
		void draw_plane(float aw, float ah, float ad, float ax,float ay, float az, float arot, float atw, float ath);

		ofVideoGrabber 		vidGrabber;
		unsigned char * 	videoInverted;
		ofTexture			videoTexture;
		int 				camWidth;
		int 				camHeight;

		ofTexture		texScreen;
		ofTexture		texScreen2;
		ofTexture		texFlow3;
		ofTexture		texSpeakr;
        ofTexture		tex2;
        ofTexture		tex3;
        ofTexture		tex4;
         ofTexture		tex5;

		float	spin;
		float	spinPct;
		float 			counter;
		float hvel;
		float hX;
		int texwarp;
		int texdelta;
		int modeCounter;

		//
	ofxCamera camera;

	ofxLight light1; //this will be a directional light
	ofxLight light2; //this one a spot light
	ofxLight light3; //and this one a point light
	ofxLight light4;
    int r;
    int g;
    int b;
	ofImage Image1;
	ofImage Image2;
	ofImage Image3;
    ofImage Image4;
    ofImage Image5;
    ofImage Image6;

	float centerX, centerY, centerZ;
	float rotX, rotY, rotZ;
	float lerpdepth;
	float lerpdelta;

	bool bSmoothLight;
	float camX, camY, camZ;

	//--audio stuff
	ofSoundPlayer 		beat;


		float 				* fftSmoothed;
		// we will draw a rectangle, bouncing off the wall:
		float 				px, py, vx, vy;

		int nBandsToGet;
		float prevx, prevy;
		float adelta,adelta2;
		float adeltabass;
		float adelta_treb;

		//---------------------------------custom stuff particles
		vector <hair_particle> gHairList;  //dynamic array for objects

        vector <hair_particle> gHairList2;  //dynamic array for objects

		vector <hair_particle> gHairList3;  //dynamic array for objects

		vector <hair_particle> gHairList4;  //dynamic array for objects

		vector <hair_particle> gHairList5;  //dynamic array for objects


		int aval;
		int w;
		int h;

};

#endif
