#include "hair_particle2.h"
// hair particle drawing class by don relyea
// www.donrelyea.com
// July 22 2008

hair_particle2::hair_particle2(void){
	 pActive=false; //init particle not active
}

void hair_particle2::update_frame(){

	//if im active lets draw
   if (pActive=true){
    domyangle();  //decide which way to grow
    doforward(); //grow
    pScale=pScale-0.20; //Decay the scale

	if  (pScale < 4){ //keep it at least 1 pixel size
      //pScale=1;
	  reset_me(); //reset particle
	}

    pBlend=pBlend-pDecay; //Decay the blend

	//Draw Routine here
	//ofSetColor(pBorW,pBorW,pBorW,pBlend); //set color and alpha blend
	//ofEnableAlphaBlending(); //enable alpha blending
	//ofCircle(myX,myY, pScale); //draw a circle
	//ofDisableAlphaBlending(); //disable alpha blending

	//reset if particle gets so transparent as to not be visible
    if  (pBlend < 15){
      reset_me(); //reset particle
	}
   }
}
void hair_particle2::reset_me(){
	//reset so we can recyle the particle
	//why have in sep function?
	//Bcuz we might want to be able to kill particles by calling this function
	 pActive=false;
}
bool hair_particle2::active(){
	// am i busy or ready for a new assignment
	 return pActive;
}
int hair_particle2::get_value(){
	// get the particle value
	 return pBorW;
}
float hair_particle2::get_blend(){
	// get the particle value
	 return pBlend;
}
float hair_particle2::get_myX(){
	// get the particle value
	 return myX;
}
float hair_particle2::get_myY(){
	// get the particle value
	 return myY;
}
float hair_particle2::get_scale(){
	// get the particle value
	 return pScale;
}
void hair_particle2::doforward(){
 //making progress every frame
 myX = myX +cos(myAngle)*myspeed;
 myY = myY +sin(myAngle)*myspeed;

}
void hair_particle2::domyangle(){
	//which way am I going during my brief existence
	mydelta=mydelta+ofRandom(-myKink,myKink);

	float adelta = mydelta/57.2958;

	myAngle = myAngle +adelta; //increment the angle

	//keep the angle between 0 and 360
	if (myAngle > 360){
		myAngle=  myAngle-360;
	}
	if (myAngle < 0){
		myAngle=  myAngle+360;
	}

}
void hair_particle2::draw_me( float ablend, float asize, float aloch, float alocv){
	//----this code initializes the particle------//
	pActive=true; //its alive!
	myKink=ofRandom(0,3); //Kinky is better =)
	myX = aloch; //give the particle a starting point
	myY = alocv; //notice veiled reference to old director lingo lol
	myAngle = ofRandom(0,360); //grow hair in random direction
	myspeed = ofRandom(1.25,6.3); //move one pixel a frame

	if (ablend > 210){
		pBorW=0; //black hair, pBorW=255; for white hair
		//pBorW=255-ablend;  //greyscale hair
		pScale=asize*80;  //root of hair is thicker then scaled back, drypoint print effect
		pDecay=0.15; // how fast the particle decays
	} else if(ablend > 100 && ablend < 210){
		pBorW=0;
		//pBorW=(255-ablend); //greyscale hair tweaked darker
		pScale=asize*43.25;
		pDecay=0.35;
	} else if(ablend > 65 && ablend < 100){
		pBorW=0;
		//pBorW=(255-ablend)/2; //greyscale hair tweaked darker
		pScale=asize*22.45;
		pDecay=1.45;
	} else if(ablend > 35 && ablend < 65){
		pBorW=0;
		//pBorW=(255-ablend)/3; //greyscale hair tweaked darker
		pScale=asize*11.65;
		pDecay=0.65;
	} else if(ablend > 2 && ablend < 35){
		pBorW=0;
		//pBorW=(255-ablend)/4; //greyscale hair tweaked darker
		pScale=asize*1.35;
		pDecay=0.85;
	} else {
		pBorW=0;
		pScale=0.15;
		pDecay=0.85;
	}

  pBlend=ablend; //set the starting the alpha blend this will be reduced by the pDecay
  mydelta = ofRandom(-10,10); //initial hair kink

}
