#ifndef _TEST_APP
#define _TEST_APP

#include <vector>
#include "hair_particle.h"
#include "hair_particle2.h"

#include "ofMain.h"
#include "ofx3DUtils.h"
#include "myFBO.h"


class testApp : public ofBaseApp{

	public:

		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void resized(int w, int h);
		//---custom
		void draw_tile(float aw, float ah, float ad, float ax,float ay, float az, float arot, float atw, float ath);
		void draw_plane(float aw, float ah, float ad, float ax,float ay, float az, float arot, float atw, float ath);

		ofVideoGrabber 		vidGrabber;
		unsigned char * 	videoInverted;
		ofTexture			videoTexture;
		int 				camWidth;
		int 				camHeight;

		ofTexture		texScreen;
		ofTexture		texScreen2;
		ofTexture		texFlow3;
		ofTexture		texSpeakr;
        ofTexture		tex2;
        ofTexture		tex3_mouth;
        ofTexture		tex4_sucker;
        ofTexture		tex5;

		float	spin;
		float	spinPct;
		float 			counter;
		float hvel;
		float hX;
		int texwarp;
		int texdelta;
		int modeCounter;

		//


	float centerX, centerY, centerZ;
	float rotX, rotY, rotZ;
	float lerpdepth;
	float lerpdelta;





        vector <hair_particle2> gHairList6;  //dynamic array for objects tentacles
        vector <hair_particle> gHairList2;  //dynamic array for objects tentacles
       // vector <hair_particle2> gHairList3;  //dynamic array for objects tentacles
        vector <hair_particle> gHairList1;  //dynamic array for objects hair

		int aval;
		int w;
		int h;

		//----------FBO class
		int 	fboWidth;
		int 	fboHeight;

		myFBO fbo;
        ofImage imageOut;  //image to store screengrab
        ofImage eye;  //image to store screengrab
        ofImage sucker;  //image to store screengrab
        ofImage mouth;  //image to store screengrab
		int gFrameCounter;



};

#endif
