#pragma once
#include "ofMain.h"
//#include "ofAddons.h"

// hair particle drawing class by don relyea
// www.donrelyea.com
// July 22 2008

class hair_particle
{
public:
	hair_particle(void);


	float myX; //particle starting location x
	float myY; //particle starting location x
	float myAngle; //particle starting angle

	float mySpeed;
	float mydist;
	int myCounter;
	float mydelta;
	float myKink;
	float myspeed;

	float pScale;
	float pBlend;
	float pDecay;

	int pBorW;

	bool pActive;

	//define functions
	void draw_me( float ablend, float asize, float aloch, float alocv);
	void update_frame();
	void reset_me();
	void doforward();
	void domyangle();
	//return value funcitons
	bool active();
	int get_value();
	float get_blend();
	float get_myX();
	float get_myY();
	float get_scale();
	float get_angle();

	vector <hair_particle> gHairList;  //dynamic array for objects

};
