#ifndef _MY_FBO
#define _MY_FBO


#include "ofMain.h"
//#include "ofAddons.h"

class myFBO{

	public:

		void init(int w, int h, bool dbuffer);

		void swapIn();
		void swapOut();

		void clear();
		void swapTex();
		int read_tex, write_tex;
		void render(float x, float y, float w, float h, bool flipY);
		void checkStatus();


	protected:

		GLuint fbo;
		GLuint depthBuffer;
		GLenum att_point[2];

		int 			width, height;

		unsigned int 	textureName[2];
		bool dbuffer;


		void clean();


};

#endif
