#include "testApp.h"

//--------------------------------------------------------------
// Disclaimer: this code is quick and sloppy so if you use it do so at your own risk
// I just dont have time to clean it up and was just trying to make something cool and quick for my kids
// did not expect to end up with anything worth sharing so you will find a lot of left over cut and pasted
// code that is probably not being used.
//
// it compiles and works in code blocks and requires openframeworks 0.06
//
// enjoy
// Don Relyea Oct 2009
// www.donrelyea.com

void testApp::setup(){

    //load Images

    ofSetCircleResolution(36);

    modeCounter=0;

	camWidth 		= 1920/2;	// try to grab at this size. variable names are left over from a previous version of this program
	camHeight 		= 1100/2;

    //load images
    eye.loadImage("eye.png");
    mouth.loadImage("mouth1.png");
    sucker.loadImage("mouth2.png");

	texScreen.allocate(1920,1100,GL_RGBA);

    //allocate textures
	tex2.allocate(240,240,GL_RGBA);

	tex3_mouth.allocate(240,240,GL_RGBA);
    tex4_sucker.allocate(260,260,GL_RGBA);

    tex2.loadData(eye.getPixels(),240,240, GL_RGBA);
    tex3_mouth.loadData(mouth.getPixels(),240,240, GL_RGBA);
    tex4_sucker.loadData(sucker.getPixels(),260,260, GL_RGBA);

    spin	= 12.0;
	spinPct	= 0.0;


	counter = 0;
	hvel=0.35;
	hX=0;
	texwarp=0;
	texdelta=0;

	lerpdepth=350;
	lerpdelta=1;



	w=1920;
	h=1100;
	//-----------------------------------spawn the particles add to array.
	//you can add more if you want,


    for(int i=0; i < 4; i++){
		gHairList6.push_back(hair_particle2() );
	}

	for(int i=0; i < 6; i++){
		gHairList2.push_back(hair_particle() );
	}


	 for(int i=0; i < 120; i++){
		gHairList1.push_back(hair_particle() );
	}


	//initialize FBO
	fboWidth 		= 1920;
	fboHeight 		= 1100;

//	fboWidth 		= 600;
//	fboHeight 		= 600;

	fbo.init(fboWidth, fboHeight, false);

	fbo.swapIn();
	//ofSetColor(255,255,255);
	//ofRect(0,0,4095,4095);
	fbo.swapOut();
}


//--------------------------------------------------------------
void testApp::update(){

//    lerpdepth=lerpdepth+lerpdelta;
//    if (lerpdepth > 360) {lerpdelta = -lerpdelta;}
//    if (lerpdepth < 240) {lerpdelta = -lerpdelta;}

    counter = counter+1;
		//-----------------------------------------------------update particles
	int tempctr=0;
	for(int i=0; i < gHairList6.size(); i++){
		//if a particle is active
		if (gHairList6[i].active()){
			//update the particle
			gHairList6[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList6[i].active() && (ofRandom(1,100) < 3) ){
			//pick an arbitrary value in the array of values

            tempctr=tempctr+1;
			aval=256;
            if (tempctr < 3){
			//initialize the particle
			gHairList6[i].draw_me( aval, tempctr*2, w-lerpdepth/2, lerpdepth/2);
            }


		}
	}

    tempctr=0;
	for(int i=0; i < gHairList2.size(); i++){
		//if a particle is active
		if (gHairList2[i].active()){
			//update the particle
			gHairList2[i].update_frame();
		}
		//if a particle is NOT active lets recycle it
		if (!gHairList2[i].active() && (ofRandom(1,100) < 3) ){
			//pick an arbitrary value in the array of values

            tempctr=tempctr+1;
			aval=256;
            if (tempctr < 3){
			//initialize the particle
			gHairList2[i].draw_me( aval, tempctr*2, w-lerpdepth/2, lerpdepth/2);
            }
		}
	}

    for(int i=0; i < gHairList1.size(); i++){
		//if a particle is active
		if (gHairList1[i].active()){
			//update the particle
			gHairList1[i].update_frame();
		}

        if (!gHairList1[i].active()){
            if (ofRandom(0,5000) < 10){
                int anobject=ofRandom(1,gHairList6.size());
                if (gHairList6[anobject].active()){
                    float anx=gHairList6[anobject].get_myX();
                    float ay=gHairList6[anobject].get_myY();
                    int avalue=gHairList6[anobject].get_value();
                    float ascale=gHairList6[anobject].get_scale();
                    float ablend=gHairList6[anobject].get_blend();

                   // printf("draw %f partnum-- %d x-- %f  y-- %f",ablend, anobject,anx,ay );

                    gHairList1[i].draw_me( ablend, ascale/70,anx,ay);

                }
            }
        }

	}


}
//--------------------------------------------------------------
void testApp::draw(){
ofEnableAlphaBlending();


//--------------------------------------------------------------------FBO tentacles
    fbo.swapIn();
    for(int i=0; i < gHairList6.size(); i++){
		//if a particle is active
		if (gHairList6[i].active()){
			//draw particle to fbo---------------------------------<<<<draw here
			//gHairList[i].update_frame();

			float anx=gHairList6[i].get_myX();
			float ay=gHairList6[i].get_myY();
			int avalue=gHairList6[i].get_value();
			float ablend=gHairList6[i].get_blend();
			float ascale=gHairList6[i].get_scale();

			//Draw Routine here
			ofSetColor(avalue,avalue,avalue,ablend); //set color and alpha blend

//
//                //----------------------------------
                    ofSetColor(255,255,255,255);
                    tex2.draw(anx,ay,ascale,ascale);
//                //----------------------------------
                     if (gHairList6[i].get_scale() < 130){
                        gHairList6[i].reset_me();
                    }

		}

	}

	for(int i=0; i < gHairList2.size(); i++){
		//if a particle is active
		if (gHairList2[i].active()){
			//draw particle to fbo---------------------------------<<<<draw here
			//gHairList[i].update_frame();

			float anx=gHairList2[i].get_myX();
			float ay=gHairList2[i].get_myY();
			int avalue=gHairList2[i].get_value();
			float ablend=gHairList2[i].get_blend();
			float ascale=gHairList2[i].get_scale();

			//Draw Routine here
			ofSetColor(avalue,avalue,avalue,ablend); //set color and alpha blend

               //----------------------------------
                    ofSetColor(255,255,255,255);
                    tex3_mouth.draw(anx,ay,ascale,ascale);
             //----------------------------------
            if (gHairList2[i].get_scale() < 120){
                gHairList2[i].reset_me();
            }
		}

	}

	 for(int i=0; i < gHairList1.size(); i++){
		//if a particle is active
		if (gHairList1[i].active()){
			//draw particle to fbo---------------------------------<<<<draw here
			//gHairList[i].update_frame();

			float anx=gHairList1[i].get_myX();
			float ay=gHairList1[i].get_myY();
			int avalue=gHairList1[i].get_value();
			float ablend=gHairList1[i].get_blend();
			float ascale=gHairList1[i].get_scale();

			//Draw Routine here
			ofSetColor(avalue,avalue,avalue,ablend); //set color and alpha blend

//                //----------------------------------
                    ofSetColor(255,255,255,255);
                    tex2.draw(anx,ay,ascale,ascale);
//                //----------------------------------
             if (ofRandom(1,2500) < 15){
                gHairList1[i].reset_me();
            }


		}

	}


     tex3_mouth.draw(1900-lerpdepth/2,-lerpdepth/2,lerpdepth,lerpdepth);

	fbo.swapOut();
	//draw the FBO to the screen
    //ofBackground(255,255,ofRandom(1,255));
	glPushMatrix();
	ofEnableAlphaBlending();
	//fbo.clear();
    ofSetColor(255,255,255,255);
	//fbo.render(0,0,1920,1100, true);
	 //glRotatef(counter,0.0f,0.0f,0.0f);



	fbo.render(0,0,camWidth, camHeight, true);
    fbo.render(1920,0,-camWidth,camHeight, true);
	fbo.render(1920,1100,-camWidth,-camHeight, true);
	fbo.render(0,1100,camWidth,-camHeight, true);

	ofDisableAlphaBlending();

	glPopMatrix();

//--------------------------------------------------------------------End FBO tentacles



    ofDisableAlphaBlending();

}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){



	if (key == 'm' || key == 'M'){
		modeCounter= modeCounter+1;
        if (modeCounter > 5){ modeCounter=2;}
	}



	//fbo.clear();
	if (key == 'n' || key == 'N'){
	     fbo.swapIn();
		fbo.clear();
		 fbo.swapOut();
	}



}


//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

   // fbo.render(0, 0, 1920, 1080, TRUE);

	//grab screen and save it
	gFrameCounter=gFrameCounter+1; //lets save different states of the drawing
	imageOut.grabScreen(0, 0, 1920,1100);


	//this can be used render out video frames if you want too you just need to
	//put it in a function that is called every frame

	imageOut.saveImage("renders/000"+ofToString(gFrameCounter)+".png");

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){


}

//--------------------------------------------------------------
void testApp::resized(int w, int h){

}
void testApp::draw_plane(float aw, float ah, float ad, float ax,float ay, float az, float arot, float atw, float ath){
    glPushMatrix();

	//this function is not needed to make monsters, its left over code from something else
	glTranslatef(ax,ay,az);

	glRotatef(arot,0.0f,1.0f,0.0f);

    float w=aw;
    float h =ah;
    float scale= ad;

    float tw=atw;
    float th=ath;

	glBegin(GL_QUADS);


    //  Face
		glTexCoord2f(1.0f*tw, 0.0f); glVertex3f(1.0f*w, -1.0f*h, -1.0f*scale);
		glTexCoord2f(1.0f*tw, 1.0f*th); glVertex3f(1.0f*w,  1.0f*h, -1.0f*scale);
		glTexCoord2f(0.0f, 1.0f*th); glVertex3f( -1.0f*w,  1.0f*h, -1.0f*scale);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -1.0f*w, -1.0f*h, -1.0f*scale);

	glEnd();

 glPopMatrix();
}
void testApp::draw_tile(float aw, float ah, float ad, float ax,float ay, float az, float arot,float atw, float ath){
    glPushMatrix();
    //this function is not needed to make monsters, its left over code from something else

	glTranslatef(ax,ay,az);


	glRotatef(arot,0.0f,1.0f,0.0f);

    float w=aw;
    float h =ah;
    float scale=ad;
    float tw=atw;
    float th=ath;

	glBegin(GL_QUADS);

	// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f*w, -1.0f*h,  1.0f*scale);
		glTexCoord2f(1.0f*tw, 0.0f); glVertex3f( 1.0f*w, -1.0f*h,  1.0f*scale);
		glTexCoord2f(1.0f*tw, 1.0f*th); glVertex3f( 1.0f*w,  1.0f*h,  1.0f*scale);
		glTexCoord2f(0.0f, 1.0f*th); glVertex3f(-1.0f*w,  1.0f*h,  1.0f*scale);
		// Back Face
		glTexCoord2f(1.0f*tw, 0.0f); glVertex3f(-1.0f*w, -1.0f*h, -1.0f*scale);
		glTexCoord2f(1.0f*tw, 1.0f*th); glVertex3f(-1.0f*w,  1.0f*h,-1.0f*scale);
		glTexCoord2f(0.0f, 1.0f*th); glVertex3f( 1.0f*w,  1.0f*h, -1.0f*scale);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f*w, -1.0f*h, -1.0f*scale);
		// Top Face
		 glVertex3f(-1.0f*w,  1.0f*h, -1.0f*scale);
		glVertex3f(-1.0f*w,  1.0f*h,  1.0f*scale);
		 glVertex3f( 1.0f*w,  1.0f*h,  1.0f*scale);
		 glVertex3f( 1.0f*w,  1.0f*h, -1.0f*scale);
		// Bottom Face
		glVertex3f(-1.0f*w, -1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w,-1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w, -1.0f*h,  1.0f*scale);
        glVertex3f(-1.0f*w, -1.0f*h,  1.0f*scale);
		// Right face
		glVertex3f( 1.0f*w, -1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w,  1.0f*h, -1.0f*scale);
		glVertex3f( 1.0f*w,  1.0f*h,  1.0f*scale);
		glVertex3f( 1.0f*w, -1.0f*h,  1.0f*scale);
		// Left Face
		glVertex3f(-1.0f*w, -1.0f*h, -1.0f*scale);
		glVertex3f(-1.0f*w, -1.0f*h,  1.0f*scale);
		glVertex3f(-1.0f*w,  1.0f*h,  1.0f*scale);
		glVertex3f(-1.0f*w,  1.0f*h, -1.0f*scale);
	glEnd();
	 //ofxLightsOff();
 glPopMatrix();
}
